=== debian/changelog ===
faiss (1.7.0-1) unstable; urgency=medium

  * New upstream version 1.7.0
  * Remove already upstreamed patches.
  * Clarify that this package is configured as CPU-only. (Closes: #982839)

 -- Mo Zhou <lumin@debian.org>  Wed, 17 Feb 2021 15:22:35 +0800

faiss (1.6.5-1) unstable; urgency=medium

  * Add the missing B-D libgtest-dev.
  * CMake: patch to use system GTest instead of downloaded one.
  * Rewrite the gtest patch and introduce FAISS_USE_SYSTEM_GTEST flag.
  * Enable hardening, and disable BUILD_TESTING on all non-amd64 arches.
  * Apply wrap-and-sort.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 25 Nov 2020 14:56:29 +0800

faiss (1.6.5-1~exp1) experimental; urgency=medium

  * New upstream version 1.6.5 (Closes: #975369)

 -- Mo Zhou <lumin@debian.org>  Tue, 24 Nov 2020 13:40:31 +0800
