=== debian/tests/control ===
Tests: test.py
Restrictions: allow-stderr
